/*
 ---------------------------------------------------------------------------
 Copyright (c) 2008, Aleksandra Mileva, UGD, Republic of Macedonia. All rights reserved.

 LICENSE TERMS

 The free distribution and use of this software in both source and binary
 form is allowed (with or without changes) provided that:

   1. distributions of this source code include the above copyright
      notice, and this list of conditions and the following disclaimer;

   2. distributions in binary form include the above copyright
      notice, this list of conditions and the following disclaimer
      in the documentation and/or other associated materials;

   3. the copyright holder's name is not used to endorse products
      built using this software without specific written permission.

 ALTERNATIVELY, provided that this notice is retained in full, this product
 may be distributed under the terms of the GNU General Public License (GPL),
 in which case the provisions of the GPL apply INSTEAD OF those given above.

 DISCLAIMER

 This software is provided 'as is' with no explicit or implied warranties
 in respect of its properties, including, but not limited to, correctness
 and/or fitness for purpose.
 ---------------------------------------------------------------------------
 Issue Date: 03/05/2008

 Usage: 
 nasha_IV.exe >> IntermediateValuesKAT_224.txt
 224

 nasha_IV.exe >> IntermediateValuesKAT_256.txt
 256
 
 nasha_IV.exe >> IntermediateValuesKAT_384.txt
 384

 nasha_IV.exe >> IntermediateValuesKAT_512.txt
 512
 */
#if defined( DUAL_CORE )
#include <windows.h>
#endif
#include <stdio.h>
#include <memory.h>
#include <stdlib.h>
#include <math.h>

#include "Nasha.h"

typedef HashReturn (*f)(int, const BitSequence*, DataLength, BitSequence*);
typedef struct{
	hashState hs;
	f fh;
}hash_ctx;


unsigned char   buf[125000];

int main(void)
{   int i,j, hashl,dlen;

	hash_ctx  hc[1];
    BitSequence  hv[64]; 

	scanf("%d",&hashl); //input hash length
	if (hashl==256)
		dlen=32;
	else if (hashl==224)
		dlen=28;
	else if (hashl==384)
		dlen=48;
	else if (hashl=512)
		dlen=64;

	printf("# IntermediateValuesKAT_%d.txt\n",hashl);
	printf("# Algorithm Name: NaSHA\n");
	printf("# Principal Submitter: Smile Markovski  \n");
	printf("# Message Digest Lenght = %d  \n\n", hashl);
	
	buf[0]='S';buf[1]='T';buf[2]='I';buf[3]='P';
	j=32;
	
	printf("##############################################################################\n \n");
	printf("              One Block Message Sample\n");
	printf("              Input Message: ");

	for (i=0;i<(j/8);i++)
		printf("%c", buf[i]);
	printf("\n\n");
	printf("=============================================================================\n \n");
	printf("Initial Hash Values: \n");
	hc->fh=Hash;
	hc->fh(hashl, buf, j, hv);
	for (i=4; i<56;i++)
		buf[i]=buf[i%4];
	j=56*8;
	printf("\n");
	printf("##############################################################################\n \n");
	printf("              Two Block Message Sample\n");
	printf("              Input Message: ");

	for (i=0;i<(j/8);i++)
		printf("%c", buf[i]);
	printf("\n\n");
	printf("=============================================================================\n \n");
	printf("Initial Hash Values: \n");

	hc->fh(hashl, buf, j, hv);
	return 0;
}
